<template>
  <div class="home">
    <ButtonComponent
      big
      @click="onViewUser"
      :disabled="userSelected === null"
      label="Consultar Perfil">
    </ButtonComponent>
    <UserList
      :users="filteredUsers"
      :headers="listHeaders"
      @select-user="onSelectUser" />
    <FilterComponent />
  </div>
</template>

<style lang="scss" scoped>
</style>

<script>
// @ is an alias to /src
import UserList from '@/components/UserList.vue';
import FilterComponent from '@/components/FilterComponent.vue';
import ButtonComponent from '@/components/ButtonComponent.vue';
import { mapGetters } from 'vuex';

export default {
  name: 'Home',
  components: {
    UserList,
    FilterComponent,
    ButtonComponent,
  },
  data() {
    return {
      listHeaders: ['Gender', 'Nombre', 'Email', 'Nacionalidad', 'Fecha de Nacimiento', 'Fecha de Registro'],
      userSelected: null,
    };
  },
  mounted() {
    if (!this.users.length) {
      this.$store.dispatch('getUserDataList');
    }
  },
  computed: {
    ...mapGetters({
      users: 'userDataList',
      filteredUsers: 'filteredUserDataList',
    }),
  },
  methods: {
    onSelectUser(user) {
      this.userSelected = user;
    },
    onViewUser() {
      this.$router.push({ name: 'UserInfo', params: { user: this.userSelected } });
    },
  },
};
</script>
